//@author: antokhio
//@help: template for standard shaders
//@tags: template
//@credits: 
struct Particle
{
	float2 uv;
	float4 col;
};



StructuredBuffer<Particle> particle;

Texture2D tex0;
SamplerState s0:IMMUTABLE {Filter=MIN_MAG_MIP_LINEAR;AddressU=CLAMP;AddressV=CLAMP;};

float4x4 tW : WORLD;
float4x4 tVP : VIEWPROJECTION;

struct VS_IN
{
	float4 pos : POSITION;
	float4 uv : TEXCOORD0;
	uint ii : SV_InstanceID;
};

struct VS_OUT
{
    float4 pos: SV_POSITION;
    float4 uv: TEXCOORD0;
	float4 col : COLOR;
};

VS_OUT VS(VS_IN input)
{
    VS_OUT output = (VS_OUT)0;
	float4 p = input.pos;
	p.xy += particle[input.ii].uv;
    output.pos  = mul(p,mul(tW,tVP));
    output.uv = input.uv;
	output.col = particle[input.ii].col;
    return output;
}

float4 PS(VS_OUT input): SV_Target
{
    return input.col;
}

technique10 Template
{
	pass P0
	{
		SetVertexShader( CompileShader( vs_4_0, VS() ) );
		SetPixelShader( CompileShader( ps_4_0, PS() ) );
	}
}




